
#include <a_samp>

#define ICON_CONNECT 200
#define ICON_DISCONNECT 201

enum server_type_e
{
     server_sa = 0,
	 server_cr
}

new server_type_e:server_type;

main()
{
	
}

forward init_classes_sa();
forward init_classes_cr();

forward init_vehicles_sa();
forward init_vehicles_cr();

forward init_objects_sa();
forward init_objects_cr();

forward init_objects_sa();
forward init_objects_cr();

forward init_npc_sa();
forward init_npc_cr();

forward player_init_icons_sa(player_id);
forward player_init_icons_cr(player_id);

forward player_init_for_class_sa(player_id);
forward player_init_for_class_cr(player_id);

forward player_spawn_sa(player_id);
forward player_spawn_cr(player_id);

stock server_type_e:get_server_type() 
{
    new version[64];
    GetServerVarAsString("version", version, sizeof(version));
    
    if(0 == strcmp(version, "cr", false, 2))
	{
        return server_cr;
    }
    
    return server_sa;
}

public OnGameModeInit()
{
    server_type = get_server_type();
	
	printf("Init simple gamemode %s", get_server_desc(server_type));
	{
		new rconcmd[256];
		format(rconcmd, sizeof(rconcmd), "mapname %s", get_server_desc(server_type));
		SendRconCommand(rconcmd);
	}

	SetGameModeText("Simple");
	call_by_gametype("init_classes");
	call_by_gametype("init_vehicles");
	call_by_gametype("init_objects");
	call_by_gametype("init_npc");

	return 1;
}

public OnPlayerConnect(playerid)
{
    SendDeathMessage(INVALID_PLAYER_ID, playerid, ICON_CONNECT);
	
	call_by_gametype_i("player_init_icons", playerid);
	
	SendClientMessage(playerid, 0x00AA00FF, "Send adaptation cmds...");
	
	send_adaptation_cmd(playerid, "get_version");
	send_adaptation_cmd(playerid, "get_lang");
	send_adaptation_cmd(playerid, "get_custom_hash");
	// send_adaptation_cmd(playerid, "test_ping");
	
	return 1;
}

public OnPlayerDisconnect(playerid)
{
    SendDeathMessage(INVALID_PLAYER_ID, playerid, ICON_DISCONNECT);
	return 1;
}

public OnPlayerDeath(playerid, killerid, reason)
{
	SendDeathMessage(killerid, playerid, reason);
	ResetPlayerMoney(playerid);
	return 1;
}

public OnPlayerRequestClass(playerid, classid)
{
	call_by_gametype_i("player_init_for_class", playerid);
	return 1;
}

public OnPlayerSpawn(playerid)
{
	call_by_gametype_i("player_spawn", playerid);
	
	GivePlayerMoney(playerid, 10000);
	
	return 1;
}

public OnVehicleMod(playerid, vehicleid, componentid)
{
	if(server_sa != server_type)
	{
		return 0;
	}
	return 1;
}

public OnVehiclePaintjob(playerid, vehicleid, paintjobid) 
{
	if(server_sa != server_type)
	{
		return 0;
	}
	return 1;
}

public OnVehicleRespray(playerid, vehicleid, color1, color2)
{
	if(server_sa != server_type)
	{
		return 0;
	}
	return 1;
}

public OnPlayerCommandText(playerid, cmdtext[])
{
	new cmd[256];
	new idx;
	cmd = strtok(cmdtext, idx);

	if (0 == strcmp("$response", cmd, true))
	{
		new response_cmd[256];
		new response_data[256];
		response_cmd = strtok(cmdtext, idx);
		strcat(response_data, cmdtext[idx+1]);

		new text[256];
		format(text, sizeof(text), "Receive response of cmd '{FFFFFF}%s{00AA00}': '{FFFFFF}%s{00AA00}'", response_cmd, response_data);
		SendClientMessage(playerid, 0x00AA00FF, text);
		
	    return 1;
	}

	if (0 == strcmp("/kill", cmdtext, true))
	{
		SetPlayerHealth(playerid, 0.0);
		return 1;
	}
	
	if (0 == strcmp(cmdtext, "/1", true))
	{
		new Text:txtSprite1;
		
		txtSprite1 = TextDrawCreate(200.0, 220.0, "samaps:map"); // Текстура txdfile:texture
		TextDrawFont(txtSprite1, 4); // 4 шрифт рисования спрайта
		TextDrawColor(txtSprite1, 0xFFFFFFFF);
		TextDrawTextSize(txtSprite1, 200.0, 200.0); // Размер изображения Ширина:Высота
		TextDrawShowForPlayer(playerid, txtSprite1);
		
		return 1;
	}
	
	if (0 == strcmp(cmd, "/acmd", true))
	{
	    new acmd_text[256];

   		format(acmd_text, sizeof(acmd_text), "%s", cmdtext[6]);
		
		if(!strlen(acmd_text))
		{
			SendClientMessage(playerid, 0xFF0000FF, "USAGE: /acmd <cmd_name>");
			return 1;
		}
		
		send_adaptation_cmd(playerid, acmd_text);

		new buff[255];
	    format(buff, sizeof(buff), "Adaptation command sended for player: {FFFFFF}%s", acmd_text);
		SendClientMessage(playerid, 0x00FF00FF, buff);

		return 1;
	}
	
	if (0 == strcmp(cmd, "/skin", true))
	{
	    new skin_text[256];

   		skin_text = strtok(cmdtext, idx);
		
		if(!strlen(skin_text))
		{
			SendClientMessage(playerid,0xFF0000FF,"USAGE: /skin <skin_id>");
			return 1;
		}
		
		SetPlayerSkin(playerid, strval(skin_text));

		return 1;
	}
	
	return 0;
}

stock call_by_gametype(const function_prefix[])
{
    new buff[255];
    format(buff, sizeof(buff), "%s_%s", function_prefix, get_server_name(server_type));
    CallLocalFunction(buff, "");
}

stock call_by_gametype_i(const function_prefix[], i1)
{
    new buff[255];
    format(buff, sizeof(buff), "%s_%s", function_prefix, get_server_name(server_type));
    CallLocalFunction(buff, "i", i1);
}

stock get_server_desc(server_type_e:t)
{
    new result[64];
	
	if(server_cr == t)
	{
        strcat(result, "Criminal Russia");
    }
    else
	{
        strcat(result, "San Andreas");
    }
	
    return result;
}

stock get_server_name(server_type_e:t)
{
    new result[64];
	
    if(server_cr == t)
	{
        strcat(result, "cr");
    }
    else
	{
        strcat(result, "sa");
    }
	
    return result;
}

stock strtok(const string[], &index)
{
	new length = strlen(string);
	
	while ((index < length) && (string[index] <= ' '))
	{
		index++;
	}

	new offset = index;
	new result[256];
	
	while ((index < length) && (string[index] > ' ') && ((index - offset) < (sizeof(result) - 1)))
	{
		result[index - offset] = string[index];
		index++;
	}
	
	result[index - offset] = EOS;
	return result;
}

stock send_adaptation_cmd(player_id, const acmd_name[])
{
	new cmd_raw[144];
	format(cmd_raw, sizeof(cmd_raw), "$cmd %s", acmd_name);
	SendClientMessage(player_id, 0x01010101, cmd_raw);
}

public init_classes_sa()
{
	for(new i = 0; i < 300; ++i)
	{
	    AddPlayerClass(i, 1958.3783, 1343.1572, 15.3746, 270.0, 46, 1, 24, 500, 0, 0);
	}
}

public init_classes_cr()
{
	for(new i = 0; i < 300; ++i)
	{
	    AddPlayerClass(i, 553.2108, 855.5515, 14.0219, 180.0, 46, 1, 24, 500, 0, 0);
	}
}

public init_vehicles_sa()
{
	AddStaticVehicle(522,2029.1477,1350.8763,10.3915,225.9742,3,8);
	AddStaticVehicle(522,2029.0470,1345.1724,10.3851,223.8668,6,25);
	AddStaticVehicle(522,2028.8029,1334.1494,10.3909,324.1750,7,79);
	AddStaticVehicle(522,2028.9355,1330.7014,10.3914,309.0145,8,82);
}

public init_vehicles_cr()
{
	AddStaticVehicle(520,2529.3201,-2181.7600,22.6899,270.0000,0,0);
	AddStaticVehicle(405,2577.6262,-2174.7920,21.8355,179.6034,36,1);
	// AddStaticVehicle(410,2573.3704,-2174.6943,21.7203,179.7061,9,1);
	AddStaticVehicle(562,2573.3704,-2174.6943,21.7203,179.7061,9,1);
	AddStaticVehicle(425,2585.5505,-2190.7563,22.6221,223.7395,43,0);
	AddStaticVehicle(522,2555.2427,-2174.5510,21.5366,180.4943,8,82);
}

public init_objects_sa()
{
	
}

public init_objects_cr()
{
	// From thread 'MAH_MOST' - sections from movable bridge
    CreateObject(2168, 2747.37, -1261.92, 21.5922, 0, 0, 0);
    CreateObject(2294, 2747.37, -1142.84, 21.5922, 0, 0, 180.0);
}

public init_npc_sa()
{
	
}

public init_npc_cr()
{
    ConnectNPC("crtest","crtest");
}

public player_init_icons_sa(player_id)
{
	
}

public player_init_icons_cr(player_id)
{
	// Pay'n'Spay
    SetPlayerMapIcon(player_id, 1, -402.779, 1009.8, 13.2477, 63, 0, MAPICON_LOCAL); // ARZAMAS
    SetPlayerMapIcon(player_id, 2, -1611.46, 1544.69, 36.2602, 63, 0, MAPICON_LOCAL); // SCHWARZ
    SetPlayerMapIcon(player_id, 3, -2147.51, -94.3456, 26.2668, 63, 0, MAPICON_LOCAL); // LYTKARINO
}

public player_init_for_class_sa(player_id)
{
 	SetPlayerInterior(player_id, 14);
	SetPlayerPos(player_id, 258.4893, -41.4008, 1002.0234);
	SetPlayerFacingAngle(player_id, 270.0);
	SetPlayerCameraPos(player_id, 256.0815, -43.0475, 1004.0234);
	SetPlayerCameraLookAt(player_id, 258.4893, -41.4008, 1002.0234);
}

public player_init_for_class_cr(player_id)
{
 	SetPlayerInterior(player_id, 0);
	SetPlayerPos(player_id, 2679.1013, -2535.1406, 21.8786);
	SetPlayerFacingAngle(player_id, 90.0);
	SetPlayerCameraPos(player_id, 2676.5026, -2534.2717, 21.7785);
	SetPlayerCameraLookAt(player_id, 2685.1298, -2539.2526, 22.6501);
}

public player_spawn_sa(player_id)
{
	SetPlayerInterior(player_id, 0);
	SetPlayerPos(player_id, 1958.3783, 1343.1572, 15.3746);
	SetPlayerFacingAngle(player_id, 270.0);
}

public player_spawn_cr(player_id)
{
	if(IsPlayerNPC(player_id))
	{
	    SetPlayerSkin(player_id, 277);
	}
	else
	{
		SetPlayerInterior(player_id, 0);
		SetPlayerPos(player_id, 2554.8867, -2205.5896, 22.4543);
		SetPlayerFacingAngle(player_id, 0.0);
	}
}